﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_polygon_selector
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The polygons.
        private List<Point[]> Polygons = new List<Point[]>();

        // The polygon selector.
        private PolygonSelector Selector;

        // Prepare the selector.
        private void Form1_Load(object sender, EventArgs e)
        {
            Selector = new PolygonSelector(picCanvas, new Pen(Color.Red, 3));
            Selector.PolygonSelected += Selector_PolygonSelected;
        }

        // The user has selected a polygon. Save it.
        void Selector_PolygonSelected(object sender, PolygonEventArgs args)
        {
            // Save the new polygon.
            Polygons.Add(args.Points.ToArray());

            // Redraw.
            picCanvas.Refresh();
        }

        // Draw any existing polygons.
        private void picCanvas_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(picCanvas.BackColor);
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            using (Pen pen = new Pen(Color.Green, 3))
            {
                foreach (Point[] polygon in Polygons)
                {
                    e.Graphics.DrawPolygon(pen, polygon);
                }
            }
        }

        private void chkDrawPolygons_CheckedChanged(object sender, EventArgs e)
        {
            Selector.Enabled = chkDrawPolygons.Checked;
        }
    }
}
